package com.logicbig.example;

import java.util.*;

public class CircularCollectionWithLimit {

    public static <T, C extends Collection<T>> void addWithLimit(C c, T itemToAdd, int limit) {
        List<T> list = new ArrayList<>(c);
        list.add(itemToAdd);
        while (list.size() > limit) {
            list.remove(0);
        }
        c.clear();
        c.addAll(list);
    }

    public static void main(String[] args) {
        int limit = 4;
        List<Integer> l = new ArrayList<>(List.of(4, 3));
        System.out.println("given list: " + l);
        addWithLimit(l, 6, limit);
        System.out.println(l);
        addWithLimit(l, 7, limit);
        System.out.println(l);
        addWithLimit(l, 8, limit);
        System.out.println(l);

        Set<Integer> s = new LinkedHashSet<>(List.of(4, 3));
        System.out.println("given LinkedHashSet: " + s);
        addWithLimit(s, 6, limit);
        System.out.println(s);
        addWithLimit(s, 7, limit);
        System.out.println(s);
        addWithLimit(s, 8, limit);
        System.out.println(s);

        Queue<Integer> q = new ArrayDeque<>(List.of(4, 3));
        System.out.println("given ArrayDeque: " + q);
        addWithLimit(q, 6, limit);
        System.out.println(q);
        addWithLimit(q, 7, limit);
        System.out.println(q);
        addWithLimit(q, 8, limit);
        System.out.println(q);
    }
}